/* GCC */

#include <fstream>
#include <string>
#include <vector>
#include <map>
#include <set>

struct Link
{
    std::string name;
    std::string connection;
};

Link link(std::string name,std::string connection)
{
    Link answer = {name,connection};
    return answer;
};

std::string getName(const std::string& modified)
{
    std::string answer = modified;
    if(answer[answer.size()-1] == '')
        answer[answer.size()-1] = '';
    else if(answer[answer.size()-1] == '')
        answer[answer.size()-1] = '';
    else if(answer[answer.size()-1] == '')
        answer = std::string(answer.begin(),answer.end()-1);
    return answer;
}

enum sex{male,female};

int getSex(const std::string& name)
{
    std::string answer = name;
    return (answer[answer.size()-1] == '' || answer[answer.size()-1] == '');
}

void dfs(std::map<std::string,std::map<std::string,std::string> >& lex,
         std::map<std::string,std::vector<Link> >& graph,std::map<std::string,std::string*>& inside,
         std::set<std::string> used,std::string current,std::string binding,std::string& currentAnswer)
{
    if(used.find(current) != used.end())
        return;
    used.insert(current);
    for(std::vector<Link>::iterator i = graph[current].begin();i != graph[current].end();i++)
    {
        std::string temp;
        if(i->name == binding)
        {
            currentAnswer = i->connection;
            return;
        }
        dfs(lex,graph,inside,used,i->name,binding,temp);
        if(!temp.empty())
        {
            currentAnswer = lex[inside[i->connection][getSex(current)]][temp];
            return;
        }
    }
}

int main()
{
    std::map<std::string,std::string> father;
    father[""] = "";
    father[""] = "";
    father[""] = "";
    father[""] = "";
    father[""] = "";
    father[""] = "";
    father[""] = "";
    father[""] = "";

    std::map<std::string,std::string> mother;
    mother[""] = "";
    mother[""] = "";
    mother[""] = "";
    mother[""] = "";
    mother[""] = "";
    mother[""] = "";
    mother[""] = "";
    mother[""] = "";

    std::map<std::string,std::string> son;
    son[""] = "";
    son[""] = "";
    son[""] = "";
    son[""] = "";
    son[""] = "";
    son[""] = "";
    son[""] = "";
    son[""] = "";
    son[""] = "";
    son[""] = "";
    son[""] = " ";
    son[""] = " ";

    std::map<std::string,std::string> dother;
    dother[""] = "";
    dother[""] = "";
    dother[""] = "";
    dother[""] = "";
    dother[""] = "";
    dother[""] = "";
    dother[""] = "";
    dother[""] = "";
    dother[""] = "";
    dother[""] = "";
    dother[""] = " ";
    dother[""] = " ";

    std::map<std::string,std::string> husband;
    husband[""] = "";
    husband[""] = "";

    std::map<std::string,std::string> wife;
    wife[""] = "";
    wife[""] = "";

    std::map<std::string,std::map<std::string,std::string> > lex;
    lex[""] = father;
    lex[""] = mother;
    lex[""] = son;
    lex[""] = dother;
    lex[""] = husband;
    lex[""] = wife;

    std::map<std::string,std::string*> insideOut;
    std::string child[2] = {"",""};
    std::string parent[2] = {"",""};
    std::string brothers[2] = {"",""};
    std::string pair[2] = {"",""};
    std::string child2[2] = {"",""};
    std::string parent2[2] = {"",""};

    insideOut[""] = parent;
    insideOut[""] = parent;
    insideOut[""] = child;
    insideOut[""] = child;
    insideOut[""] = brothers;
    insideOut[""] = brothers;
    insideOut[""] = pair;
    insideOut[""] = pair;
    insideOut[""] = parent2;
    insideOut[""] = parent2;
    insideOut[""] = child2;
    insideOut[""] = child2;

    std::map<std::string,std::vector<Link> > graph;

    std::ifstream in("family.in");
    std::string unknown;
    std::string binding;
    std::string connected;
    std::string connection;
    std::string modified;
    std::string line;
    in >> unknown >> binding;
    while(std::getline(in,line))
    {
        if(line.empty())
            continue;
        std::string::iterator i = line.begin();
        for(;i != line.end() && *i != ' ';i++);
        connected = std::string(line.begin(),i);
        i++;
        for(;i != line.end() && *i != ' ';i++);
        i++;
        std::string::iterator left = i;
        for(;i != line.end() && *i != ' ';i++);
        connection = std::string(left,i);
        left = ++i;
        for(;i != line.end() && *i != ' ';i++);
        modified = std::string(left,i);
        graph[getName(modified)].push_back(link(connected,connection));
        graph[connected].push_back(link(getName(modified),insideOut[connection][getSex(getName(modified))]));
    }
    in.close();
    std::string answer;
    std::set<std::string> used;
    dfs(lex,graph,insideOut,used,binding,unknown,answer);
    std::ofstream out("family.out");
/*    for(std::map<std::string,std::vector<Link> >::iterator i = graph.begin();i != graph.end();i++)
        for(int j = 0;j < i->second.size();j++)
            out << i->second[j].name << ' ' << i->second[j].connection << ' ' << i->first << std::endl;*/
    out << unknown << " - " << answer << ' ' << binding << "" << std::endl;
    out.close();
}
